﻿Imports Microsoft.VisualBasic

Public Class QuoteProcessor
    Public Function getBuildingsQuote(ByVal buildingsDetails As BuildingsDTO) As Double
        Dim premium As Double = 0.0
        Dim basicQuote As Double = buildingsDetails.MarketValue * 0.002
        Dim propertyType As String = buildingsDetails.PropertyType
        If (propertyType.Equals("apartment")) Then
            premium = basicQuote * 0.95
        End If
        If (propertyType.Equals("semi")) Then
            premium = basicQuote * 1.05
        End If
        If (propertyType.Equals("terraced")) Then
            premium = basicQuote
        End If
        If (propertyType.Equals("detached")) Then
            premium = basicQuote * 1.1
        End If
        premium = premium + (buildingsDetails.BedroomCount * (premium / 100))
        Dim year As Integer = buildingsDetails.ConstructionDate.Year
        If (year = "00") Then
            premium += premium * 0.04
        End If
        If (year = "01") Then
            premium += premium * 0.03
        End If
        If (year = "51") Then
            premium += premium * 0.02
        End If
        If (year = "71") Then
            premium += premium * 0.01
        End If
        If (buildingsDetails.ConstructionType().Equals("timber")) Then
            premium += (premium * 0.1)
        End If
        Return premium
    End Function

    Public Function getContentsQuote(ByVal contentsDetails As ContentsDTO) As Double
        Dim accidentalCover As Boolean = contentsDetails.AccidentalCover
        Dim cover As Integer = contentsDetails.CoverAmount
        Dim deductible As Integer = contentsDetails.DeductibleAmount
        Dim premium As Double = cover * 0.004
        If (accidentalCover) Then
            premium *= 1.25
        End If
        If (deductible >= 1000) Then
            premium -= (premium * 0.2)
        ElseIf (deductible >= 500) Then
            premium -= (premium * 0.1)
        End If
        Return premium
    End Function
End Class
